/**
** This software is distributed under the terms of the General Public License.  
** 
** Program : BuildIT!
** Version : 0.2
** Authors : Artur Prusakiewicz <prusak@mat.uni.torun.pl>
**	     Michal Switala <scisly@mat.uni.torun.pl>
** E-MAIL  : build@mat.uni.torun.pl
** WWW     : http://www.mat.uni.torun.pl/~scisly/buildit/
**           http://www.mat.uni.torun.pl/~prusak/buildit/
**/
#define _MENU_BAR
#include <qpushbt.h> 
#include <qlabel.h>
#include <qlist.h> 
#include <qstring.h>

Q_DECLARE(QListM,QString);

class MyMenuItem
{
public:
  MyMenuItem(QString text,int what);
  void setLabel(QString val){label=val;}
  QString getLabel(){return label;}
  bool isMenu(){return sub_menu;}
  void setCB(bool val);
  void setState(bool val);
  bool isCB();
  bool getState();
  void setShc(int val){shc=val;}
  void setMod(int val){mod=val;}
  int getShc();
  int getMod();
  void setKeys(QString val){keys=val;}
  QString getKeys(){return keys;}
  bool separator;
private:
  QString label;
  QString keys;
  int shc,mod;
  bool sub_menu,is_cb,on;
};

class MyMenuBar;
class MyMenu;

Q_DECLARE(QListM,MyMenuItem);

class MyMenu: public QLabel
{ 
  Q_OBJECT
public:
  MyMenu(const char * text, QWidget * parent=0, const char * name=0);
  MyMenuBar *father;
  void setShc(int sval,int mval,QString kval){shc=sval;mod=mval;keys=kval;}
  int getShc(){return shc;}
  int getMod(){return mod;}
  QString getKeys(){return keys;}
  void seyKeys(QString val){keys=val;}
  QListM(MyMenuItem) items;
  QListM(QString) evt;
  bool help;
 public slots:
 void semOp();
 void semDown();
signals:
  void mv(QWidget *widget,QMouseEvent *event);
  void press(QWidget *widget,QMouseEvent *event);
  void release(QWidget *widget,QMouseEvent *event);
  void dbclick(QWidget *widget,QMouseEvent *event);
  void touch(QWidget *widget);
  void noEnter();
  void leave();
private:
  bool sem;
  int shc,mod;
  bool sub;
  QString keys;
  void mouseMoveEvent(QMouseEvent *event){emit touch(this);emit mv(this,event);}
  void mousePressEvent(QMouseEvent *event){emit touch(this);emit press(this,event);}  
  void mouseReleaseEvent(QMouseEvent *event){emit touch(this);emit release(this,event);}
  void mouseDoubleClickEvent(QMouseEvent *event){emit touch(this);emit dbclick(this,event);}
  void leaveEvent(QEvent *event){emit leave();} 
};

Q_DECLARE(QListM,MyMenu);

class MyMenuBar:public QPushButton
{
  Q_OBJECT
public:
  MyMenuBar(QWidget * parent=0,const char * name=0);
  void setId(QString val){id=val;};
  QString getId(){return id;}  
  void addMenu(MyMenu *widget);
  void rmMenu(MyMenu *val);
  void adjust();
  QListM(MyMenu) menus; 
  QListM(QString) evt;
 public slots:
 void semOp();
 void semDown();
signals:
  void mv(QWidget *widget,QMouseEvent *event);
  void press(QWidget *widget,QMouseEvent *event);
  void release(QWidget *widget,QMouseEvent *event);
  void dbclick(QWidget *widget,QMouseEvent *event);
  void touch(QWidget *widget);
  void noEnter();
  void leave();
private:
  bool sem;
  int click;
  QString id;

  void mouseMoveEvent(QMouseEvent *event){emit touch(this);emit mv(this,event);}
  void mousePressEvent(QMouseEvent *event){emit touch(this);emit press(this,event);}  
  void mouseReleaseEvent(QMouseEvent *event){emit touch(this);emit release(this,event);}
  void mouseDoubleClickEvent(QMouseEvent *event){emit touch(this);emit dbclick(this,event);}
  void leaveEvent(QEvent *event){emit leave();}
};
